osg::DisplaySettings Class Reference

`#include <DisplaySettings>`

Inheritance diagram for osg::DisplaySettings:

## Public Types

enum | DisplayType { MONITOR , POWERWALL , REALITY_CENTER , HEAD_MOUNTED_DISPLAY }
enum | StereoMode { QUAD_BUFFER , ANAGLYPHIC , HORIZONTAL_SPLIT , VERTICAL_SPLIT , LEFT_EYE , RIGHT_EYE , HORIZONTAL_INTERLACE , VERTICAL_INTERLACE , CHECKERBOARD }
enum | SplitStereoHorizontalEyeMapping { LEFT_EYE_LEFT_VIEWPORT , LEFT_EYE_RIGHT_VIEWPORT }
enum | SplitStereoVerticalEyeMapping { LEFT_EYE_TOP_VIEWPORT , LEFT_EYE_BOTTOM_VIEWPORT }
enum | ImplicitBufferAttachment { IMPLICIT_DEPTH_BUFFER_ATTACHMENT = (1 << 0) , IMPLICIT_STENCIL_BUFFER_ATTACHMENT = (1 << 1) , IMPLICIT_COLOR_BUFFER_ATTACHMENT = (1 << 2) , DEFAULT_IMPLICIT_BUFFER_ATTACHMENT = IMPLICIT_COLOR_BUFFER_ATTACHMENT | IMPLICIT_DEPTH_BUFFER_ATTACHMENT }
enum | SwapMethod { SWAP_DEFAULT , SWAP_EXCHANGE , SWAP_COPY , SWAP_UNDEFINED }
enum | VertexBufferHint { NO_PREFERENCE , VERTEX_BUFFER_OBJECT , VERTEX_ARRAY_OBJECT }
enum | ShaderHint { SHADER_NONE , SHADER_GL2 , SHADER_GLES2 , SHADER_GL3 , SHADER_GLES3 }
enum | OSXMenubarBehavior { MENUBAR_AUTO_HIDE , MENUBAR_FORCE_HIDE , MENUBAR_FORCE_SHOW }
typedef int | ImplicitBufferAttachmentMask
typedef std::vector< std::string > | FileNames
typedef std::vector< osg::ref_ptr< osg::Object > > | Objects

## Public Member Functions

| DisplaySettings ()
| DisplaySettings (ArgumentParser &arguments)
| DisplaySettings (const DisplaySettings &vs)
DisplaySettings & | operator= (const DisplaySettings &vs)
void | setDisplaySettings (const DisplaySettings &vs)
void | merge (const DisplaySettings &vs)
void | setDefaults ()
void | readEnvironmentalVariables ()
void | readCommandLine (ArgumentParser &arguments)
void | setDisplayType (DisplayType type)
DisplayType | getDisplayType () const
void | setStereo (bool on)
bool | getStereo () const
void | setStereoMode (StereoMode mode)
StereoMode | getStereoMode () const
void | setEyeSeparation (float eyeSeparation)
float | getEyeSeparation () const
void | setSplitStereoHorizontalEyeMapping (SplitStereoHorizontalEyeMapping m)
SplitStereoHorizontalEyeMapping | getSplitStereoHorizontalEyeMapping () const
void | setSplitStereoHorizontalSeparation (int s)
int | getSplitStereoHorizontalSeparation () const
void | setSplitStereoVerticalEyeMapping (SplitStereoVerticalEyeMapping m)
SplitStereoVerticalEyeMapping | getSplitStereoVerticalEyeMapping () const
void | setSplitStereoVerticalSeparation (int s)
int | getSplitStereoVerticalSeparation () const
void | setSplitStereoAutoAdjustAspectRatio (bool flag)
bool | getSplitStereoAutoAdjustAspectRatio () const
void | setScreenWidth (float width)
float | getScreenWidth () const
void | setScreenHeight (float height)
float | getScreenHeight () const
void | setScreenDistance (float distance)
float | getScreenDistance () const
void | setDoubleBuffer (bool flag)
bool | getDoubleBuffer () const
void | setRGB (bool flag)
bool | getRGB () const
void | setDepthBuffer (bool flag)
bool | getDepthBuffer () const
void | setMinimumNumAlphaBits (unsigned int bits)
unsigned int | getMinimumNumAlphaBits () const
bool | getAlphaBuffer () const
void | setMinimumNumStencilBits (unsigned int bits)
unsigned int | getMinimumNumStencilBits () const
bool | getStencilBuffer () const
void | setMinimumNumAccumBits (unsigned int red, unsigned int green, unsigned int blue, unsigned int alpha)
unsigned int | getMinimumNumAccumRedBits () const
unsigned int | getMinimumNumAccumGreenBits () const
unsigned int | getMinimumNumAccumBlueBits () const
unsigned int | getMinimumNumAccumAlphaBits () const
bool | getAccumBuffer () const
void | setMaxNumberOfGraphicsContexts (unsigned int num)
unsigned int | getMaxNumberOfGraphicsContexts () const
void | setNumMultiSamples (unsigned int samples)
unsigned int | getNumMultiSamples () const
bool | getMultiSamples () const
void | setCompileContextsHint (bool useCompileContexts)
bool | getCompileContextsHint () const
void | setSerializeDrawDispatch (bool serializeDrawDispatch)
bool | getSerializeDrawDispatch () const
void | setUseSceneViewForStereoHint (bool hint)
bool | getUseSceneViewForStereoHint () const
void | setNumOfDatabaseThreadsHint (unsigned int numThreads)
unsigned int | getNumOfDatabaseThreadsHint () const
void | setNumOfHttpDatabaseThreadsHint (unsigned int numThreads)
unsigned int | getNumOfHttpDatabaseThreadsHint () const
void | setApplication (const std::string &application)
const std::string & | getApplication ()
void | setMaxTexturePoolSize (unsigned int size)
unsigned int | getMaxTexturePoolSize () const
void | setMaxBufferObjectPoolSize (unsigned int size)
unsigned int | getMaxBufferObjectPoolSize () const
void | setImplicitBufferAttachmentMask (ImplicitBufferAttachmentMask renderMask=DisplaySettings::DEFAULT_IMPLICIT_BUFFER_ATTACHMENT, ImplicitBufferAttachmentMask resolveMask=DisplaySettings::DEFAULT_IMPLICIT_BUFFER_ATTACHMENT)
void | setImplicitBufferAttachmentRenderMask (ImplicitBufferAttachmentMask implicitBufferAttachmentRenderMask)
void | setImplicitBufferAttachmentResolveMask (ImplicitBufferAttachmentMask implicitBufferAttachmentResolveMask)
ImplicitBufferAttachmentMask | getImplicitBufferAttachmentRenderMask () const
ImplicitBufferAttachmentMask | getImplicitBufferAttachmentResolveMask () const
void | setSwapMethod (SwapMethod swapMethod)
SwapMethod | getSwapMethod (void)
void | setSyncSwapBuffers (unsigned int numFrames=0)
unsigned int | getSyncSwapBuffers () const
void | setGLContextVersion (const std::string &version)
const std::string | getGLContextVersion () const
void | setGLContextFlags (unsigned int flags)
unsigned int | getGLContextFlags () const
void | setGLContextProfileMask (unsigned int mask)
unsigned int | getGLContextProfileMask () const
void | setNvOptimusEnablement (int value)
int | getNvOptimusEnablement () const
void | setVertexBufferHint (VertexBufferHint gi)
VertexBufferHint | getVertexBufferHint () const
void | setShaderHint (ShaderHint hint, bool setShaderValues=true)
ShaderHint | getShaderHint () const
void | setTextShaderTechnique (const std::string &str)
const std::string & | getTextShaderTechnique () const
void | setKeystoneHint (bool enabled)
bool | getKeystoneHint () const
void | setKeystoneFileNames (const FileNames &filenames)
FileNames & | getKeystoneFileNames ()
const FileNames & | getKeystoneFileNames () const
void | setKeystones (const Objects &objects)
Objects & | getKeystones ()
const Objects & | getKeystones () const
OSXMenubarBehavior | getOSXMenubarBehavior () const
void | setOSXMenubarBehavior (OSXMenubarBehavior hint)
virtual osg::Matrixd | computeLeftEyeProjectionImplementation (const osg::Matrixd &projection) const
virtual osg::Matrixd | computeLeftEyeViewImplementation (const osg::Matrixd &view, double eyeSeperationScale=1.0) const
virtual osg::Matrixd | computeRightEyeProjectionImplementation (const osg::Matrixd &projection) const
virtual osg::Matrixd | computeRightEyeViewImplementation (const osg::Matrixd &view, double eyeSeperationScale=1.0) const
void | setValue (const std::string &name, const std::string &value)
bool | getValue (const std::string &name, std::string &value, bool use_getenv_fallback=true) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static ref_ptr< DisplaySettings > & | instance ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef std::map< std::string, std::string > | ValueMap

## Protected Member Functions

virtual | ~DisplaySettings ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

DisplayType | _displayType
bool | _stereo
StereoMode | _stereoMode
float | _eyeSeparation
float | _screenWidth
float | _screenHeight
float | _screenDistance
SplitStereoHorizontalEyeMapping | _splitStereoHorizontalEyeMapping
int | _splitStereoHorizontalSeparation
SplitStereoVerticalEyeMapping | _splitStereoVerticalEyeMapping
int | _splitStereoVerticalSeparation
bool | _splitStereoAutoAdjustAspectRatio
bool | _doubleBuffer
bool | _RGB
bool | _depthBuffer
unsigned int | _minimumNumberAlphaBits
unsigned int | _minimumNumberStencilBits
unsigned int | _minimumNumberAccumRedBits
unsigned int | _minimumNumberAccumGreenBits
unsigned int | _minimumNumberAccumBlueBits
unsigned int | _minimumNumberAccumAlphaBits
unsigned int | _maxNumOfGraphicsContexts
unsigned int | _numMultiSamples
bool | _compileContextsHint
bool | _serializeDrawDispatch
bool | _useSceneViewForStereoHint
unsigned int | _numDatabaseThreadsHint
unsigned int | _numHttpDatabaseThreadsHint
std::string | _application
unsigned int | _maxTexturePoolSize
unsigned int | _maxBufferObjectPoolSize
ImplicitBufferAttachmentMask | _implicitBufferAttachmentRenderMask
ImplicitBufferAttachmentMask | _implicitBufferAttachmentResolveMask
std::string | _glContextVersion
unsigned int | _glContextFlags
unsigned int | _glContextProfileMask
SwapMethod | _swapMethod
unsigned int | _syncSwapBuffers
VertexBufferHint | _vertexBufferHint
ShaderHint | _shaderHint
std::string | _textShaderTechnique
bool | _keystoneHint
FileNames | _keystoneFileNames
Objects | _keystones
OSXMenubarBehavior | _OSXMenubarBehavior
OpenThreads::Mutex | _valueMapMutex
ValueMap | _valueMap
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

DisplaySettings class for encapsulating what visuals are required and have been set up, and the status of stereo viewing.

## Member Typedef Documentation

## FileNames

typedef std::vector<std::string> osg::DisplaySettings::FileNames

## ImplicitBufferAttachmentMask

typedef int osg::DisplaySettings::ImplicitBufferAttachmentMask

## Objects

typedef std::vector< osg::ref_ptr<osg::Object> > osg::DisplaySettings::Objects

## ValueMap

typedef std::map<std::string, std::string> osg::DisplaySettings::ValueMap

protected

## Member Enumeration Documentation

## DisplayType

enum osg::DisplaySettings::DisplayType

Enumerator
MONITOR |
POWERWALL |
REALITY_CENTER |
HEAD_MOUNTED_DISPLAY |

## ImplicitBufferAttachment

enum osg::DisplaySettings::ImplicitBufferAttachment

Methods used to set and get defaults for Cameras implicit buffer attachments. For more info: See description of Camera::setImplicitBufferAttachment method

DisplaySettings implicit buffer attachment selection defaults to: DEPTH and COLOR for both primary (Render) FBO and secondary Multisample (Resolve) FBO ie: IMPLICIT_DEPTH_BUFFER_ATTACHMENT | IMPLICIT_COLOR_BUFFER_ATTACHMENT

Enumerator
IMPLICIT_DEPTH_BUFFER_ATTACHMENT |
IMPLICIT_STENCIL_BUFFER_ATTACHMENT |
IMPLICIT_COLOR_BUFFER_ATTACHMENT |
DEFAULT_IMPLICIT_BUFFER_ATTACHMENT |

## OSXMenubarBehavior

enum osg::DisplaySettings::OSXMenubarBehavior

Enumerator
MENUBAR_AUTO_HIDE |
MENUBAR_FORCE_HIDE |
MENUBAR_FORCE_SHOW |

## ShaderHint

enum osg::DisplaySettings::ShaderHint

Enumerator
SHADER_NONE |
SHADER_GL2 |
SHADER_GLES2 |
SHADER_GL3 |
SHADER_GLES3 |

## SplitStereoHorizontalEyeMapping

enum osg::DisplaySettings::SplitStereoHorizontalEyeMapping

Enumerator
LEFT_EYE_LEFT_VIEWPORT |
LEFT_EYE_RIGHT_VIEWPORT |

## SplitStereoVerticalEyeMapping

enum osg::DisplaySettings::SplitStereoVerticalEyeMapping

Enumerator
LEFT_EYE_TOP_VIEWPORT |
LEFT_EYE_BOTTOM_VIEWPORT |

## StereoMode

enum osg::DisplaySettings::StereoMode

Enumerator
QUAD_BUFFER |
ANAGLYPHIC |
HORIZONTAL_SPLIT |
VERTICAL_SPLIT |
LEFT_EYE |
RIGHT_EYE |
HORIZONTAL_INTERLACE |
VERTICAL_INTERLACE |
CHECKERBOARD |

## SwapMethod

enum osg::DisplaySettings::SwapMethod

Enumerator
SWAP_DEFAULT |
SWAP_EXCHANGE |
SWAP_COPY |
SWAP_UNDEFINED |

## VertexBufferHint

enum osg::DisplaySettings::VertexBufferHint

Enumerator
NO_PREFERENCE |
VERTEX_BUFFER_OBJECT |
VERTEX_ARRAY_OBJECT |

## Constructor & Destructor Documentation

## DisplaySettings() [1/3]

osg::DisplaySettings::DisplaySettings | ( |  | ) |

inline

References readEnvironmentalVariables(), osg::Referenced::Referenced(), and setDefaults().

Referenced by DisplaySettings(), merge(), operator=(), and setDisplaySettings().

## DisplaySettings() [2/3]

osg::DisplaySettings::DisplaySettings | ( | ArgumentParser & | arguments | ) |

inline

References readCommandLine(), readEnvironmentalVariables(), osg::Referenced::Referenced(), and setDefaults().

## DisplaySettings() [3/3]

osg::DisplaySettings::DisplaySettings | ( | const DisplaySettings & | vs | ) |

References DisplaySettings().

## ~DisplaySettings()

virtual osg::DisplaySettings::~DisplaySettings | ( |  | ) |

protected virtual

## Member Function Documentation

## computeLeftEyeProjectionImplementation()

virtual osg::Matrixd osg::DisplaySettings::computeLeftEyeProjectionImplementation | ( | const osg::Matrixd & | projection | ) | const

virtual

helper function for computing the left eye projection matrix.

## computeLeftEyeViewImplementation()

virtual osg::Matrixd osg::DisplaySettings::computeLeftEyeViewImplementation | ( | const osg::Matrixd & | view,
|  | double | eyeSeperationScale = 1.0 ) const

virtual

helper function for computing the left eye view matrix.

## computeRightEyeProjectionImplementation()

virtual osg::Matrixd osg::DisplaySettings::computeRightEyeProjectionImplementation | ( | const osg::Matrixd & | projection | ) | const

virtual

helper function for computing the right eye view matrix.

## computeRightEyeViewImplementation()

virtual osg::Matrixd osg::DisplaySettings::computeRightEyeViewImplementation | ( | const osg::Matrixd & | view,
|  | double | eyeSeperationScale = 1.0 ) const

virtual

helper function for computing the right eye view matrix.

## getAccumBuffer()

bool osg::DisplaySettings::getAccumBuffer | ( |  | ) | const

inline

References _minimumNumberAccumAlphaBits, _minimumNumberAccumBlueBits, _minimumNumberAccumGreenBits, and _minimumNumberAccumRedBits.

## getAlphaBuffer()

bool osg::DisplaySettings::getAlphaBuffer | ( |  | ) | const

inline

References _minimumNumberAlphaBits.

## getApplication()

const std::string & osg::DisplaySettings::getApplication | ( |  | ) |

inline

References _application.

## getCompileContextsHint()

bool osg::DisplaySettings::getCompileContextsHint | ( |  | ) | const

inline

References _compileContextsHint.

## getDepthBuffer()

bool osg::DisplaySettings::getDepthBuffer | ( |  | ) | const

inline

References _depthBuffer.

## getDisplayType()

DisplayType osg::DisplaySettings::getDisplayType | ( |  | ) | const

inline

References _displayType.

## getDoubleBuffer()

bool osg::DisplaySettings::getDoubleBuffer | ( |  | ) | const

inline

References _doubleBuffer.

## getEyeSeparation()

float osg::DisplaySettings::getEyeSeparation | ( |  | ) | const

inline

References _eyeSeparation.

## getGLContextFlags()

unsigned int osg::DisplaySettings::getGLContextFlags | ( |  | ) | const

inline

Get the hint of the flags to use in when creating graphic contexts.

References _glContextFlags.

## getGLContextProfileMask()

unsigned int osg::DisplaySettings::getGLContextProfileMask | ( |  | ) | const

inline

Get the hint of the profile mask to use in when creating graphic contexts.

References _glContextProfileMask.

## getGLContextVersion()

const std::string osg::DisplaySettings::getGLContextVersion | ( |  | ) | const

inline

Get the hint of which OpenGL version to attempt to create a graphics context for.

References _glContextVersion.

## getImplicitBufferAttachmentRenderMask()

ImplicitBufferAttachmentMask osg::DisplaySettings::getImplicitBufferAttachmentRenderMask | ( |  | ) | const

inline

Get mask selecting default implicit buffer attachments for Cameras primary FBOs.

References _implicitBufferAttachmentRenderMask.

Referenced by osg::Camera::getImplicitBufferAttachmentRenderMask().

## getImplicitBufferAttachmentResolveMask()

ImplicitBufferAttachmentMask osg::DisplaySettings::getImplicitBufferAttachmentResolveMask | ( |  | ) | const

inline

Get mask selecting default implicit buffer attachments for Cameras secondary MULTISAMPLE FBOs.

References _implicitBufferAttachmentResolveMask.

Referenced by osg::Camera::getImplicitBufferAttachmentResolveMask().

## getKeystoneFileNames() [1/2]

FileNames & osg::DisplaySettings::getKeystoneFileNames | ( |  | ) |

inline

References _keystoneFileNames.

## getKeystoneFileNames() [2/2]

const FileNames & osg::DisplaySettings::getKeystoneFileNames | ( |  | ) | const

inline

References _keystoneFileNames.

## getKeystoneHint()

bool osg::DisplaySettings::getKeystoneHint | ( |  | ) | const

inline

References _keystoneHint.

## getKeystones() [1/2]

Objects & osg::DisplaySettings::getKeystones | ( |  | ) |

inline

References _keystones.

## getKeystones() [2/2]

const Objects & osg::DisplaySettings::getKeystones | ( |  | ) | const

inline

References _keystones.

## getMaxBufferObjectPoolSize()

unsigned int osg::DisplaySettings::getMaxBufferObjectPoolSize | ( |  | ) | const

inline

References _maxBufferObjectPoolSize.

## getMaxNumberOfGraphicsContexts()

unsigned int osg::DisplaySettings::getMaxNumberOfGraphicsContexts | ( |  | ) | const

## getMaxTexturePoolSize()

unsigned int osg::DisplaySettings::getMaxTexturePoolSize | ( |  | ) | const

inline

References _maxTexturePoolSize.

## getMinimumNumAccumAlphaBits()

unsigned int osg::DisplaySettings::getMinimumNumAccumAlphaBits | ( |  | ) | const

inline

References _minimumNumberAccumAlphaBits.

## getMinimumNumAccumBlueBits()

unsigned int osg::DisplaySettings::getMinimumNumAccumBlueBits | ( |  | ) | const

inline

References _minimumNumberAccumBlueBits.

## getMinimumNumAccumGreenBits()

unsigned int osg::DisplaySettings::getMinimumNumAccumGreenBits | ( |  | ) | const

inline

References _minimumNumberAccumGreenBits.

## getMinimumNumAccumRedBits()

unsigned int osg::DisplaySettings::getMinimumNumAccumRedBits | ( |  | ) | const

inline

References _minimumNumberAccumRedBits.

## getMinimumNumAlphaBits()

unsigned int osg::DisplaySettings::getMinimumNumAlphaBits | ( |  | ) | const

inline

References _minimumNumberAlphaBits.

## getMinimumNumStencilBits()

unsigned int osg::DisplaySettings::getMinimumNumStencilBits | ( |  | ) | const

inline

References _minimumNumberStencilBits.

## getMultiSamples()

bool osg::DisplaySettings::getMultiSamples | ( |  | ) | const

inline

References _numMultiSamples.

## getNumMultiSamples()

unsigned int osg::DisplaySettings::getNumMultiSamples | ( |  | ) | const

inline

References _numMultiSamples.

## getNumOfDatabaseThreadsHint()

unsigned int osg::DisplaySettings::getNumOfDatabaseThreadsHint | ( |  | ) | const

inline

Get the hint for total number of threads in the DatbasePager set up, inclusive of the number of http dedicated threads.

References _numDatabaseThreadsHint.

## getNumOfHttpDatabaseThreadsHint()

unsigned int osg::DisplaySettings::getNumOfHttpDatabaseThreadsHint | ( |  | ) | const

inline

Get the hint for number of threads in the DatbasePager dedicated to reading http requests.

References _numHttpDatabaseThreadsHint.

## getNvOptimusEnablement()

int osg::DisplaySettings::getNvOptimusEnablement | ( |  | ) | const

Get the NvOptimusEnablement value.

## getOSXMenubarBehavior()

OSXMenubarBehavior osg::DisplaySettings::getOSXMenubarBehavior | ( |  | ) | const

inline

References _OSXMenubarBehavior.

## getRGB()

bool osg::DisplaySettings::getRGB | ( |  | ) | const

inline

References _RGB.

## getScreenDistance()

float osg::DisplaySettings::getScreenDistance | ( |  | ) | const

inline

References _screenDistance.

## getScreenHeight()

float osg::DisplaySettings::getScreenHeight | ( |  | ) | const

inline

References _screenHeight.

## getScreenWidth()

float osg::DisplaySettings::getScreenWidth | ( |  | ) | const

inline

References _screenWidth.

## getSerializeDrawDispatch()

bool osg::DisplaySettings::getSerializeDrawDispatch | ( |  | ) | const

inline

References _serializeDrawDispatch.

## getShaderHint()

ShaderHint osg::DisplaySettings::getShaderHint | ( |  | ) | const

inline

References _shaderHint.

## getSplitStereoAutoAdjustAspectRatio()

bool osg::DisplaySettings::getSplitStereoAutoAdjustAspectRatio | ( |  | ) | const

inline

References _splitStereoAutoAdjustAspectRatio.

## getSplitStereoHorizontalEyeMapping()

SplitStereoHorizontalEyeMapping osg::DisplaySettings::getSplitStereoHorizontalEyeMapping | ( |  | ) | const

inline

References _splitStereoHorizontalEyeMapping.

## getSplitStereoHorizontalSeparation()

int osg::DisplaySettings::getSplitStereoHorizontalSeparation | ( |  | ) | const

inline

References _splitStereoHorizontalSeparation.

## getSplitStereoVerticalEyeMapping()

SplitStereoVerticalEyeMapping osg::DisplaySettings::getSplitStereoVerticalEyeMapping | ( |  | ) | const

inline

References _splitStereoVerticalEyeMapping.

## getSplitStereoVerticalSeparation()

int osg::DisplaySettings::getSplitStereoVerticalSeparation | ( |  | ) | const

inline

References _splitStereoVerticalSeparation.

## getStencilBuffer()

bool osg::DisplaySettings::getStencilBuffer | ( |  | ) | const

inline

References _minimumNumberStencilBits.

## getStereo()

bool osg::DisplaySettings::getStereo | ( |  | ) | const

inline

References _stereo.

## getStereoMode()

StereoMode osg::DisplaySettings::getStereoMode | ( |  | ) | const

inline

References _stereoMode.

## getSwapMethod()

SwapMethod osg::DisplaySettings::getSwapMethod | ( | void |  | ) |

inline

Get preferred swap method

References _swapMethod.

## getSyncSwapBuffers()

unsigned int osg::DisplaySettings::getSyncSwapBuffers | ( |  | ) | const

inline

Set whether Arb Sync should be used to manage the swaps buffers.

References _syncSwapBuffers.

## getTextShaderTechnique()

const std::string & osg::DisplaySettings::getTextShaderTechnique | ( |  | ) | const

inline

References _textShaderTechnique.

## getUseSceneViewForStereoHint()

bool osg::DisplaySettings::getUseSceneViewForStereoHint | ( |  | ) | const

inline

References _useSceneViewForStereoHint.

## getValue()

bool osg::DisplaySettings::getValue | ( | const std::string & | name,
|  | std::string & | value,
|  | bool | use_getenv_fallback = true ) const

## getVertexBufferHint()

VertexBufferHint osg::DisplaySettings::getVertexBufferHint | ( |  | ) | const

inline

References _vertexBufferHint.

## instance()

ref_ptr< DisplaySettings > & osg::DisplaySettings::instance | ( |  | ) |

static

Maintain a DisplaySettings singleton for objects to query at runtime.

Referenced by osg::State::getActiveDisplaySettings(), osg::State::getActiveDisplaySettings(), osg::Camera::getImplicitBufferAttachmentRenderMask(), and osg::Camera::getImplicitBufferAttachmentResolveMask().

## merge()

void osg::DisplaySettings::merge | ( | const DisplaySettings & | vs | ) |

References DisplaySettings().

## operator=()

DisplaySettings & osg::DisplaySettings::operator= | ( | const DisplaySettings & | vs | ) |

References DisplaySettings().

## readCommandLine()

void osg::DisplaySettings::readCommandLine | ( | ArgumentParser & | arguments | ) |

read the commandline arguments.

Referenced by DisplaySettings().

## readEnvironmentalVariables()

void osg::DisplaySettings::readEnvironmentalVariables | ( |  | ) |

read the environmental variables.

Referenced by DisplaySettings(), and DisplaySettings().

## setApplication()

void osg::DisplaySettings::setApplication | ( | const std::string & | application | ) |

inline

References _application.

## setCompileContextsHint()

void osg::DisplaySettings::setCompileContextsHint | ( | bool | useCompileContexts | ) |

inline

References _compileContextsHint.

## setDefaults()

void osg::DisplaySettings::setDefaults | ( |  | ) |

Referenced by DisplaySettings(), and DisplaySettings().

## setDepthBuffer()

void osg::DisplaySettings::setDepthBuffer | ( | bool | flag | ) |

inline

References _depthBuffer.

## setDisplaySettings()

void osg::DisplaySettings::setDisplaySettings | ( | const DisplaySettings & | vs | ) |

References DisplaySettings().

## setDisplayType()

void osg::DisplaySettings::setDisplayType | ( | DisplayType | type | ) |

inline

References _displayType.

## setDoubleBuffer()

void osg::DisplaySettings::setDoubleBuffer | ( | bool | flag | ) |

inline

References _doubleBuffer.

## setEyeSeparation()

void osg::DisplaySettings::setEyeSeparation | ( | float | eyeSeparation | ) |

inline

References _eyeSeparation.

## setGLContextFlags()

void osg::DisplaySettings::setGLContextFlags | ( | unsigned int | flags | ) |

inline

Set the hint of the flags to use in when creating graphic contexts.

References _glContextFlags.

## setGLContextProfileMask()

void osg::DisplaySettings::setGLContextProfileMask | ( | unsigned int | mask | ) |

inline

Set the hint of the profile mask to use in when creating graphic contexts.

References _glContextProfileMask.

## setGLContextVersion()

void osg::DisplaySettings::setGLContextVersion | ( | const std::string & | version | ) |

inline

Set the hint of which OpenGL version to attempt to create a graphics context for.

References _glContextVersion.

## setImplicitBufferAttachmentMask()

void osg::DisplaySettings::setImplicitBufferAttachmentMask | ( | ImplicitBufferAttachmentMask | renderMask = DisplaySettings::DEFAULT_IMPLICIT_BUFFER_ATTACHMENT,
|  | ImplicitBufferAttachmentMask | resolveMask = DisplaySettings::DEFAULT_IMPLICIT_BUFFER_ATTACHMENT )

inline

References _implicitBufferAttachmentRenderMask, _implicitBufferAttachmentResolveMask, and DEFAULT_IMPLICIT_BUFFER_ATTACHMENT.

## setImplicitBufferAttachmentRenderMask()

void osg::DisplaySettings::setImplicitBufferAttachmentRenderMask | ( | ImplicitBufferAttachmentMask | implicitBufferAttachmentRenderMask | ) |

inline

References _implicitBufferAttachmentRenderMask.

## setImplicitBufferAttachmentResolveMask()

void osg::DisplaySettings::setImplicitBufferAttachmentResolveMask | ( | ImplicitBufferAttachmentMask | implicitBufferAttachmentResolveMask | ) |

inline

References _implicitBufferAttachmentResolveMask.

## setKeystoneFileNames()

void osg::DisplaySettings::setKeystoneFileNames | ( | const FileNames & | filenames | ) |

inline

References _keystoneFileNames.

## setKeystoneHint()

void osg::DisplaySettings::setKeystoneHint | ( | bool | enabled | ) |

inline

References _keystoneHint.

## setKeystones()

void osg::DisplaySettings::setKeystones | ( | const Objects & | objects | ) |

inline

References _keystones.

## setMaxBufferObjectPoolSize()

void osg::DisplaySettings::setMaxBufferObjectPoolSize | ( | unsigned int | size | ) |

inline

References _maxBufferObjectPoolSize.

## setMaxNumberOfGraphicsContexts()

void osg::DisplaySettings::setMaxNumberOfGraphicsContexts | ( | unsigned int | num | ) |

## setMaxTexturePoolSize()

void osg::DisplaySettings::setMaxTexturePoolSize | ( | unsigned int | size | ) |

inline

References _maxTexturePoolSize.

## setMinimumNumAccumBits()

void osg::DisplaySettings::setMinimumNumAccumBits | ( | unsigned int | red,
|  | unsigned int | green,
|  | unsigned int | blue,
|  | unsigned int | alpha )

## setMinimumNumAlphaBits()

void osg::DisplaySettings::setMinimumNumAlphaBits | ( | unsigned int | bits | ) |

inline

References _minimumNumberAlphaBits.

## setMinimumNumStencilBits()

void osg::DisplaySettings::setMinimumNumStencilBits | ( | unsigned int | bits | ) |

inline

References _minimumNumberStencilBits.

## setNumMultiSamples()

void osg::DisplaySettings::setNumMultiSamples | ( | unsigned int | samples | ) |

inline

References _numMultiSamples.

## setNumOfDatabaseThreadsHint()

void osg::DisplaySettings::setNumOfDatabaseThreadsHint | ( | unsigned int | numThreads | ) |

inline

Set the hint for the total number of threads in the DatbasePager set up, inclusive of the number of http dedicated threads.

References _numDatabaseThreadsHint.

## setNumOfHttpDatabaseThreadsHint()

void osg::DisplaySettings::setNumOfHttpDatabaseThreadsHint | ( | unsigned int | numThreads | ) |

inline

Set the hint for number of threads in the DatbasePager to dedicate to reading http requests.

References _numHttpDatabaseThreadsHint.

## setNvOptimusEnablement()

void osg::DisplaySettings::setNvOptimusEnablement | ( | int | value | ) |

Set the NvOptimusEnablement value. Default can be set using OSG_NvOptimusEnablement env var.

## setOSXMenubarBehavior()

void osg::DisplaySettings::setOSXMenubarBehavior | ( | OSXMenubarBehavior | hint | ) |

inline

References _OSXMenubarBehavior.

## setRGB()

void osg::DisplaySettings::setRGB | ( | bool | flag | ) |

inline

References _RGB.

## setScreenDistance()

void osg::DisplaySettings::setScreenDistance | ( | float | distance | ) |

inline

References _screenDistance.

## setScreenHeight()

void osg::DisplaySettings::setScreenHeight | ( | float | height | ) |

inline

References _screenHeight.

## setScreenWidth()

void osg::DisplaySettings::setScreenWidth | ( | float | width | ) |

inline

References _screenWidth.

## setSerializeDrawDispatch()

void osg::DisplaySettings::setSerializeDrawDispatch | ( | bool | serializeDrawDispatch | ) |

inline

References _serializeDrawDispatch.

## setShaderHint()

void osg::DisplaySettings::setShaderHint | ( | ShaderHint | hint,
|  | bool | setShaderValues = true )

set the ShaderHint to tells shader generating cdoes version to create. By default also OSG_GLSL_VERSION and OSG_PRECISION_FLOAT values that can get use directly in shaders using $OSG_GLSL_VERSION and $OSG_PRECISION_FLOAT respectively.

## setSplitStereoAutoAdjustAspectRatio()

void osg::DisplaySettings::setSplitStereoAutoAdjustAspectRatio | ( | bool | flag | ) |

inline

References _splitStereoAutoAdjustAspectRatio.

## setSplitStereoHorizontalEyeMapping()

void osg::DisplaySettings::setSplitStereoHorizontalEyeMapping | ( | SplitStereoHorizontalEyeMapping | m | ) |

inline

References _splitStereoHorizontalEyeMapping.

## setSplitStereoHorizontalSeparation()

void osg::DisplaySettings::setSplitStereoHorizontalSeparation | ( | int | s | ) |

inline

References _splitStereoHorizontalSeparation.

## setSplitStereoVerticalEyeMapping()

void osg::DisplaySettings::setSplitStereoVerticalEyeMapping | ( | SplitStereoVerticalEyeMapping | m | ) |

inline

References _splitStereoVerticalEyeMapping.

## setSplitStereoVerticalSeparation()

void osg::DisplaySettings::setSplitStereoVerticalSeparation | ( | int | s | ) |

inline

References _splitStereoVerticalSeparation.

## setStereo()

void osg::DisplaySettings::setStereo | ( | bool | on | ) |

inline

References _stereo.

## setStereoMode()

void osg::DisplaySettings::setStereoMode | ( | StereoMode | mode | ) |

inline

References _stereoMode.

## setSwapMethod()

void osg::DisplaySettings::setSwapMethod | ( | SwapMethod | swapMethod | ) |

inline

Select preferred swap method

References _swapMethod.

## setSyncSwapBuffers()

void osg::DisplaySettings::setSyncSwapBuffers | ( | unsigned int | numFrames = 0 | ) |

inline

Set whether Arb Sync should be used to manage the swaps buffers, 0 disables the use of the sync, greater than zero enables sync based on number of frames specified.

References _syncSwapBuffers.

## setTextShaderTechnique()

void osg::DisplaySettings::setTextShaderTechnique | ( | const std::string & | str | ) |

inline

Set the TextShaderTechnique that is used in the Text default constructor to choose which osgText::ShaderTechnique to use.

References _textShaderTechnique.

## setUseSceneViewForStereoHint()

void osg::DisplaySettings::setUseSceneViewForStereoHint | ( | bool | hint | ) |

inline

References _useSceneViewForStereoHint.

## setValue()

void osg::DisplaySettings::setValue | ( | const std::string & | name,
|  | const std::string & | value )

## setVertexBufferHint()

void osg::DisplaySettings::setVertexBufferHint | ( | VertexBufferHint | gi | ) |

inline

References _vertexBufferHint.

## Member Data Documentation

## _application

std::string osg::DisplaySettings::_application

protected

Referenced by getApplication(), and setApplication().

## _compileContextsHint

bool osg::DisplaySettings::_compileContextsHint

protected

Referenced by getCompileContextsHint(), and setCompileContextsHint().

## _depthBuffer

bool osg::DisplaySettings::_depthBuffer

protected

Referenced by getDepthBuffer(), and setDepthBuffer().

## _displayType

DisplayType osg::DisplaySettings::_displayType

protected

Referenced by getDisplayType(), and setDisplayType().

## _doubleBuffer

bool osg::DisplaySettings::_doubleBuffer

protected

Referenced by getDoubleBuffer(), and setDoubleBuffer().

## _eyeSeparation

float osg::DisplaySettings::_eyeSeparation

protected

Referenced by getEyeSeparation(), and setEyeSeparation().

## _glContextFlags

unsigned int osg::DisplaySettings::_glContextFlags

protected

Referenced by getGLContextFlags(), and setGLContextFlags().

## _glContextProfileMask

unsigned int osg::DisplaySettings::_glContextProfileMask

protected

Referenced by getGLContextProfileMask(), and setGLContextProfileMask().

## _glContextVersion

std::string osg::DisplaySettings::_glContextVersion

protected

Referenced by getGLContextVersion(), and setGLContextVersion().

## _implicitBufferAttachmentRenderMask

ImplicitBufferAttachmentMask osg::DisplaySettings::_implicitBufferAttachmentRenderMask

protected

Referenced by getImplicitBufferAttachmentRenderMask(), setImplicitBufferAttachmentMask(), and setImplicitBufferAttachmentRenderMask().

## _implicitBufferAttachmentResolveMask

ImplicitBufferAttachmentMask osg::DisplaySettings::_implicitBufferAttachmentResolveMask

protected

Referenced by getImplicitBufferAttachmentResolveMask(), setImplicitBufferAttachmentMask(), and setImplicitBufferAttachmentResolveMask().

## _keystoneFileNames

FileNames osg::DisplaySettings::_keystoneFileNames

protected

Referenced by getKeystoneFileNames(), getKeystoneFileNames(), and setKeystoneFileNames().

## _keystoneHint

bool osg::DisplaySettings::_keystoneHint

protected

Referenced by getKeystoneHint(), and setKeystoneHint().

## _keystones

Objects osg::DisplaySettings::_keystones

protected

Referenced by getKeystones(), getKeystones(), and setKeystones().

## _maxBufferObjectPoolSize

unsigned int osg::DisplaySettings::_maxBufferObjectPoolSize

protected

Referenced by getMaxBufferObjectPoolSize(), and setMaxBufferObjectPoolSize().

## _maxNumOfGraphicsContexts

unsigned int osg::DisplaySettings::_maxNumOfGraphicsContexts

protected

## _maxTexturePoolSize

unsigned int osg::DisplaySettings::_maxTexturePoolSize

protected

Referenced by getMaxTexturePoolSize(), and setMaxTexturePoolSize().

## _minimumNumberAccumAlphaBits

unsigned int osg::DisplaySettings::_minimumNumberAccumAlphaBits

protected

Referenced by getAccumBuffer(), and getMinimumNumAccumAlphaBits().

## _minimumNumberAccumBlueBits

unsigned int osg::DisplaySettings::_minimumNumberAccumBlueBits

protected

Referenced by getAccumBuffer(), and getMinimumNumAccumBlueBits().

## _minimumNumberAccumGreenBits

unsigned int osg::DisplaySettings::_minimumNumberAccumGreenBits

protected

Referenced by getAccumBuffer(), and getMinimumNumAccumGreenBits().

## _minimumNumberAccumRedBits

unsigned int osg::DisplaySettings::_minimumNumberAccumRedBits

protected

Referenced by getAccumBuffer(), and getMinimumNumAccumRedBits().

## _minimumNumberAlphaBits

unsigned int osg::DisplaySettings::_minimumNumberAlphaBits

protected

Referenced by getAlphaBuffer(), getMinimumNumAlphaBits(), and setMinimumNumAlphaBits().

## _minimumNumberStencilBits

unsigned int osg::DisplaySettings::_minimumNumberStencilBits

protected

Referenced by getMinimumNumStencilBits(), getStencilBuffer(), and setMinimumNumStencilBits().

## _numDatabaseThreadsHint

unsigned int osg::DisplaySettings::_numDatabaseThreadsHint

protected

Referenced by getNumOfDatabaseThreadsHint(), and setNumOfDatabaseThreadsHint().

## _numHttpDatabaseThreadsHint

unsigned int osg::DisplaySettings::_numHttpDatabaseThreadsHint

protected

Referenced by getNumOfHttpDatabaseThreadsHint(), and setNumOfHttpDatabaseThreadsHint().

## _numMultiSamples

unsigned int osg::DisplaySettings::_numMultiSamples

protected

Referenced by getMultiSamples(), getNumMultiSamples(), and setNumMultiSamples().

## _OSXMenubarBehavior

OSXMenubarBehavior osg::DisplaySettings::_OSXMenubarBehavior

protected

Referenced by getOSXMenubarBehavior(), and setOSXMenubarBehavior().

## _RGB

bool osg::DisplaySettings::_RGB

protected

Referenced by getRGB(), and setRGB().

## _screenDistance

float osg::DisplaySettings::_screenDistance

protected

Referenced by getScreenDistance(), and setScreenDistance().

## _screenHeight

float osg::DisplaySettings::_screenHeight

protected

Referenced by getScreenHeight(), and setScreenHeight().

## _screenWidth

float osg::DisplaySettings::_screenWidth

protected

Referenced by getScreenWidth(), and setScreenWidth().

## _serializeDrawDispatch

bool osg::DisplaySettings::_serializeDrawDispatch

protected

Referenced by getSerializeDrawDispatch(), and setSerializeDrawDispatch().

## _shaderHint

ShaderHint osg::DisplaySettings::_shaderHint

protected

Referenced by getShaderHint().

## _splitStereoAutoAdjustAspectRatio

bool osg::DisplaySettings::_splitStereoAutoAdjustAspectRatio

protected

Referenced by getSplitStereoAutoAdjustAspectRatio(), and setSplitStereoAutoAdjustAspectRatio().

## _splitStereoHorizontalEyeMapping

SplitStereoHorizontalEyeMapping osg::DisplaySettings::_splitStereoHorizontalEyeMapping

protected

Referenced by getSplitStereoHorizontalEyeMapping(), and setSplitStereoHorizontalEyeMapping().

## _splitStereoHorizontalSeparation

int osg::DisplaySettings::_splitStereoHorizontalSeparation

protected

Referenced by getSplitStereoHorizontalSeparation(), and setSplitStereoHorizontalSeparation().

## _splitStereoVerticalEyeMapping

SplitStereoVerticalEyeMapping osg::DisplaySettings::_splitStereoVerticalEyeMapping

protected

Referenced by getSplitStereoVerticalEyeMapping(), and setSplitStereoVerticalEyeMapping().

## _splitStereoVerticalSeparation

int osg::DisplaySettings::_splitStereoVerticalSeparation

protected

Referenced by getSplitStereoVerticalSeparation(), and setSplitStereoVerticalSeparation().

## _stereo

bool osg::DisplaySettings::_stereo

protected

Referenced by getStereo(), and setStereo().

## _stereoMode

StereoMode osg::DisplaySettings::_stereoMode

protected

Referenced by getStereoMode(), and setStereoMode().

## _swapMethod

SwapMethod osg::DisplaySettings::_swapMethod

protected

Referenced by getSwapMethod(), and setSwapMethod().

## _syncSwapBuffers

unsigned int osg::DisplaySettings::_syncSwapBuffers

protected

Referenced by getSyncSwapBuffers(), and setSyncSwapBuffers().

## _textShaderTechnique

std::string osg::DisplaySettings::_textShaderTechnique

protected

Referenced by getTextShaderTechnique(), and setTextShaderTechnique().

## _useSceneViewForStereoHint

bool osg::DisplaySettings::_useSceneViewForStereoHint

protected

Referenced by getUseSceneViewForStereoHint(), and setUseSceneViewForStereoHint().

## _valueMap

ValueMap osg::DisplaySettings::_valueMap

mutable protected

## _valueMapMutex

OpenThreads::Mutex osg::DisplaySettings::_valueMapMutex

mutable protected

## _vertexBufferHint

VertexBufferHint osg::DisplaySettings::_vertexBufferHint

protected

Referenced by getVertexBufferHint(), and setVertexBufferHint().

The documentation for this class was generated from the following file:

- DisplaySettings